
function [irf,irfboot, resu,H, Bols,Sols]=CholVAR(data,nlagsvar,nlagsimpulse,cumind,ndraws)

%% variable number of inputs

if nargin <= 4
    ndraws = 0;
end
if nargin == 3
    cumind = [];
end

%% prelim

[T, n]=size(data);
 Y = data(nlagsvar+1:T,:);
 X = ones(T-nlagsvar,1);
for k=1:nlagsvar
   X = [X data(nlagsvar+1-k:T-k,:)];
end

%%  point estimates
[irf, Bols,res,Sols] = pointestimate(Y,X,nlagsvar,nlagsimpulse);
irf(cumind,:,:)=cumsum(irf(cumind,:,:),3);
H = inv(chol(Sols)')';
resu=res*H;
 %%  boot 
 if ndraws == 0
     irfboot = [];
 else
 databoot=data;
 Xboot= X;

  for i = 1:ndraws
      draw = ceil(rand(T-nlagsvar,1)*(T-nlagsvar));
      shboot = res(draw,:);
       
      for t=nlagsvar+1:T
         databoot(t,:) = Xboot(t-nlagsvar,:)*Bols' + shboot(t-nlagsvar,:);
         if t<T
         Xboot(t-nlagsvar+1,:) = [1 databoot(t,:) Xboot(t-nlagsvar,2:end-n)];
         end
      end
      
      Yboot = databoot(nlagsvar+1:T,:);   
      [irfboot(:,:,:,i)] = pointestimate(Yboot,Xboot,nlagsvar,nlagsimpulse);    
  end
 
irfboot(cumind,:,:,:)=cumsum(irfboot(cumind,:,:,:),3);     
 end
function [irf, Bols,res,Sols] = pointestimate(Y,X,nlagsvar,nlagsimpulse)
Bols=(X'*X)\X'*Y;
res=Y-X*Bols;
Sols=cov(res);
n=size(Y,2);
np=n*nlagsvar;

Bols = Bols';
A(:,:,1) = eye(n);
A(:,:,2:nlagsvar+1) = - reshape(Bols(:,2:np+1),n,n,nlagsvar);
invA = invertepolynomialmatrix(A,nlagsimpulse);
irf  = polynomialmatricesproduct(invA,chol(Sols,'lower'),nlagsimpulse);
