
clear
close all
%% setting starting and ending dates

t0b = 12;
t0 = 167;
t4 = 371;
t4bis = 371+12;
t3 = 345;
t2 = 290;
t1 = 247;

cutt0 = 2;
cutt1 = 84; % GK FF4 
cutt2 = 126; % dicembre 2008

inicut = t0b;
inicut2 = t0b;
endcut = cutt2;
endcut2 = cutt2;

%% loading  variables and instruments 
FactorsEBP2
xx = x;
instr = xx(:,126);
instrPMW = instr;
instryy = instr;
instr = instr(1+inicut:end - endcut);
instryy = instryy(1+inicut2:end - endcut);
instrPMW = instrPMW(1+t4:end - endcut2);
y = xx(1+t4:end-endcut2,1:end);
yy = xx(1+inicut2:end-endcut,1:end);

x = xx(1+inicut:end-endcut,1:end);
xxx = x;
%% computing the common components
ss = 7;
[rhat1, rhat2] = ABC_crit(standardize(x(:,1:end-ss)), 20);
rhat2
rhat3 = 8;
[pc,R,D,chi] = principalcomponents(standardize(x(:,1:end-ss)), rhat3);
stand = std(x(:,1:end-ss));
chis = chi*diag(stand);

%% setting a few parameters
H = 61;
p = 12;
p1 = p;
m = 0;
nrepli = 500;

%% choosing VAR variables

vari = [73 6  96  ];
vari1 = [73 6  96  117  69 ];
vari2 = [vari 117];
s = length(vari1);
un = find(vari1==24);
ip = find(vari==6);
cpi = find(vari==96);


spread = find(vari1==117);
ffrpos=find(vari==73);
st=find(vari1==69);
cumvar=[  ];
cumvar2=[ ip cpi st];
yy(:,[6 96 69]) = cumsum(yy(:,[6 96 69]));
x(:,[6 96 69]) = cumsum(x(:,[6 96 69]));
y(:,[6 96 69]) = cumsum(y(:,[6 96 69]));

nnn = 50;

%nomi{un}='Unemployment';
nomi{ffrpos}='1-Year Bond';
nomi{ip}='Industrial Production';
nomi{cpi}='Prices';
nomi{spread} = 'Risk spread';
nomi{st} = 'Stock Prices';
[aic,bic,hqc] = aicbic(x(:,vari),12);

%% computing IRFs and shocks

[cirf0,boot0,u0] = PROXYSVARRecoverabilityCase(x(:,vari1),instr,p,H,1,[],nrepli,ffrpos,1,m);
[cirf1,boot1,u1] = PROXYSVARRecoverabilityCase(x(:,vari),instr,p,H,1,cumvar,nrepli,ffrpos,1,m);

[cirf2,boot2,u2] = PROXYSVARRecoverabilityCase(yy(:,vari2) ,instryy,p,H,1,cumvar,nrepli,ffrpos,1,m);
[cirf3,boot3,u3] = CholVAR([instrPMW y(:,vari)],p1,H,cumvar+1,nrepli);
[cirf5,boot5,u5] = CholVAR([instrPMW y(:,[vari ])],p1,H,cumvar+1,nrepli);

[cirf4,boot4,u4] = PROXYSVARRecoverabilityCase([chis(:,vari1) pc(:,1:rhat3-length(vari1)) ],instr,p,H,1,cumvar2,nrepli,ffrpos,1,m);

for i = 1:nrepli
boot0(:,:,:,i)=boot0(:,:,:,i)/boot0(1,1,1,i);
boot1(:,:,:,i)=boot1(:,:,:,i)/boot1(1,1,1,i);
boot2(:,:,:,i)=boot2(:,:,:,i)/boot2(1,1,1,i);
boot3(:,1,:,i)=boot3(:,1,:,i)/boot3(2,1,1,i);
boot4(:,:,:,i)=boot4(:,:,:,i)/boot4(1,1,1,i);
boot5(:,:,:,i)=boot5(:,:,:,i)/boot5(1,1,1,i);
end
irfss0 = squeeze(cirf0)./cirf0(1,1,1);
irfssboot0 = squeeze(boot0);

irfss1 = squeeze(cirf1)./cirf1(1,1,1);
irfssboot1 = squeeze(boot1);

irfss2 = squeeze(cirf2)./cirf2(1,1,1);
irfssboot2 = squeeze(boot2(:,1,:,:));

irfss3 = squeeze(cirf3(2:end,1,:))./cirf3(2,1,1);
irfssboot3 = squeeze(boot3(2:end,1,:,:));

irfss4 = squeeze(cirf4)./cirf4(1,1,1);
irfssboot4 = squeeze(boot4(:,1,:,:));
bench = irfss4;
benchboot = irfssboot4;
irfss5 = squeeze(cirf5(2:end,1,:))./cirf3(2,1,1);
irfssboot5 = squeeze(boot5(2:end,1,:,:));
%% testing for fundamentalness

for i = 1:6
prob(3,i) = ortotest2(u0, pc, i);
prob(1,i) = ortotest2(u1, pc, i);
prob(2,i) = ortotest2(u2, pc, i);
%  prob(2,i) = ortotest2(u1, x(:,[69  117]), i);
%  prob(4,i) = ortotest2(u2, x(:,[69 ]), i);
% 
% prob(6,i) = ortotest2(u4, x(:,[69 117 ]), i);
% prob(4,i) = ortotest2(u3(:,1), pc(t4-inicut+1+p:end,:), i);
% prob(5,i) = ortotest2(u5(:,1), pc(t4-inicut+1+p:end,:), i);
end
prob;
Table3 = MakeTable(prob,3);

% pval = PROXYSVARInvertibilityTest([chis(:,vari1) pc(:,1:rhat3-length(vari1)) ],instr,12,8,6)
%% plotting the IRFs
n = length(vari);
KK = 31;
s=n;
figure(9)
 for i =1:n
    imp1 = [irfss1(i,1:KK)' squeeze(prctile(irfssboot1(i,1:KK,:),[ 16 84 ],3))];
     subplot(3,s,i),PlotShad2(imp1),title(nomi{i}),if i==1, ylabel('VAR I, external instr.'),end
      axis tight
    grid 'minor'
 end
for i=1:n
    imp2 = [irfss2(i,1:KK)' squeeze(prctile(irfssboot2(i,1:KK,:),[ 16 84 ],3))];
     subplot(3,s,3*1+i), PlotShad2(imp2),
     % if i==n+2, ylabel(nomi{i}), end
     if i==1, ylabel('VAR II, external instr.'), end
      axis tight
    grid 'minor'
end
for i = 1:n
    imp0 = [irfss0(i,1:KK)' squeeze(prctile(irfssboot0(i,1:KK,:),[ 16 84 ],3))];
    subplot(3,s,3*2+i),PlotShad2(imp0),%if i==n+1, title(nomi{i}),end
    if i==1, ylabel('VAR III, external instr.'),end
    axis tight
    grid 'minor'
end

     


figure(10)
for i = 1:n
    imp3 = [irfss3(i,1:KK)' squeeze(prctile(irfssboot3(i,1:KK,:),[ 16 84 ],3))];
     subplot(2,s,i),PlotShad2(imp3),title(nomi{i}),
     if i==1, ylabel('VAR I, internal instr.'),end
     % if i == n+2, ylabel(nomi{i}),
     % end
     axis tight
    grid 'minor'
     
end
 
% for i = 1:n
%     imp5 = [irfss5(i,1:KK)' squeeze(prctile(irfssboot5(i,1:KK,:),[16 84 ],3))];
%     subplot(s,3,3*(i-1)+2),PlotShad2(imp5), if i == n+1, ylabel(nomi{i}),end
% 
%     if i == 1, title('VAR IVb'),end
%       axis tight
%     grid 'minor'
% end
for i=1:n  
    imp4 = [irfss4(i,1:KK)' squeeze(prctile(irfssboot4(i,1:KK,:),[ 16 84 ],3))];
    subplot(2,s,3+i),PlotShad2(imp4),
    if i==1, ylabel('DFM'),end
    axis tight
    grid 'minor'
end



% %% using the MPI instrument
% instr = xx(:,125);
% instrPMW = instr;
% instryy = instr;
% instr = instr(1+inicut:end - endcut);
% instryy = instryy(1+inicut2:end - endcut);
% instrPMW = instrPMW(1+t4bis:end - endcut2);
% y = xx(1+t4bis:end-endcut2,1:end);
% yy = xx(1+inicut2:end-endcut,1:end);
% x = xx(1+inicut:end-endcut,1:end);
% 
% [cirf0,boot0,u0] = PROXYSVARRecoverabilityCase(x(:,vari1),instr,p,H,1,cumvar2,nrepli,ffrpos,1,m);
% [cirf1,boot1,u1] = PROXYSVARRecoverabilityCase(x(:,vari),instr,p,H,1,cumvar,nrepli,ffrpos,1,m);
% % [~,~,u14l] = PROXYSVARRecoverabilityCase(x(:,vari),instr,4,H,1,cumvar,nrepli,ffrpos,1,m);
% % [~,~,u18l] = PROXYSVARRecoverabilityCase(x(:,vari),instr,8,H,1,cumvar,nrepli,ffrpos,1,m);
% [cirf2,boot2,u2] = PROXYSVARRecoverabilityCase(yy(:,vari2) ,instryy,p,H,1,cumvar,nrepli,ffrpos,1,m);
% [cirf3,boot3,u3] = CholVAR([instrPMW y(:,vari)],p1,H,cumvar+1,nrepli);
% [cirf5,boot5,u5] = CholVAR([instrPMW y(:,vari2)],p1,H,cumvar+1,nrepli);
% 
% [cirf4,boot4,u4] = PROXYSVARRecoverabilityCase([chis(:,vari1) pc(:,1:rhat3-length(vari1)) ],instr,p,H,1,cumvar2,nrepli,ffrpos,1,m);
% 
% for i = 1:nrepli
% boot0(:,:,:,i)=boot0(:,:,:,i)/boot0(1,1,1,i);
% boot1(:,:,:,i)=boot1(:,:,:,i)/boot1(1,1,1,i);
% boot2(:,:,:,i)=boot2(:,:,:,i)/boot2(1,1,1,i);
% boot3(:,1,:,i)=boot3(:,1,:,i)/boot3(2,1,1,i);
% boot4(:,:,:,i)=boot4(:,:,:,i)/boot4(1,1,1,i);
% boot5(:,:,:,i)=boot5(:,:,:,i)/boot5(1,1,1,i);
% end
% irfss0 = squeeze(cirf0)./cirf0(1,1,1);
% irfssboot0 = squeeze(boot0);
% 
% irfss1 = squeeze(cirf1)./cirf1(1,1,1);
% irfssboot1 = squeeze(boot1);
% 
% irfss2 = squeeze(cirf2)./cirf2(1,1,1);
% irfssboot2 = squeeze(boot2(:,1,:,:));
% 
% irfss3 = squeeze(cirf3(2:end,1,:))./cirf3(2,1,1);
% irfssboot3 = squeeze(boot3(2:end,1,:,:));
% 
% irfss4 = squeeze(cirf4)./cirf4(1,1,1);
% irfssboot4 = squeeze(boot4(:,1,:,:));
% 
% irfss5 = squeeze(cirf5(2:end,1,:))./cirf3(2,1,1);
% irfssboot5 = squeeze(boot5(2:end,1,:,:));
% figure(3)
%  for i =1:n
%     imp1 = [irfss1(i,1:KK)' squeeze(prctile(irfssboot1(i,1:KK,:),[5 16 84 95],3))];
%      subplot(s,3,3*(i-1)+1),PlotShad2(imp1),ylabel(nomi{i}),if i==1, title('VAR Ia'),end
%       axis tight
%     grid 'minor'
%  end
% for i=1:length(vari1)
%     imp0 = [irfss0(i,1:KK)' squeeze(prctile(irfssboot0(i,1:KK,:),[5 16 84 95],3))];
%      subplot(s,3,3*(i-1)+2),PlotShad2(imp0)
%      if i==n+1,ylabel(nomi{i}),end
%     if i==n+2,ylabel(nomi{i}),end
%      if i==1, title('VAR IIIa'),end
%       axis tight
%     grid 'minor'
% end
% 
% for i=1:length(vari1)   
%     imp4 = [irfss4(i,1:KK)' squeeze(prctile(irfssboot4(i,1:KK,:),[5 16 84 95],3))];
%     subplot(s,3,3*(i-1)+3),PlotShad2(imp4),
%     
%     if i==1, title('DFM'),end
%     axis tight
%     grid 'minor'
% end
% 
% for i = 1:6
% 
% %prob(7,i) = ortotest2(u1, pc, i);
% 
% % prob(7,i) = ortotest2(u14l, pc, i);
% % prob(8,i) = ortotest2(u18l, pc, i);
% 
% end
% %prob

%% robustness
instr = xx(:,126);

instr = instr(1+inicut:end - endcut);

% number of lags
p1 = [6  9];
for j = 1:2
cirf = PROXYSVARRecoverabilityCase([chis(:,vari1) pc(:,1:rhat3-length(vari1)) ],instr,p1(j),H,1,cumvar2,nrepli,ffrpos,1,m);
ci(:,:,j) = squeeze(cirf)./cirf(1,1,1);
end
% instrument 
instr2 = xx(:,125);
instr2 = instr2(1+inicut:end - endcut);
cirf = PROXYSVARRecoverabilityCase([chis(:,vari1) pc(:,1:rhat3-length(vari1)) ],instr2,p,H,1,cumvar2,nrepli,ffrpos,1,m);
cirf = squeeze(cirf)./cirf(1,1,1);
% cirff = CholVAR([chis(:,[6 96 73 117 69]) pc(:,1:rhat3-length(vari1)) ],p,H,[1 2 ],1);
% cirff = cirff(:,3,:);
% cirff([1 2 3],:,:) = cirff([3 1 2],:,:);
% cirff = squeeze(cirff)./cirff(1,1,1);
% number of factors
%ss = 7;
r = [9 10];
for j = 1:2
    [pc2,R,D,chi] = principalcomponents(standardize(xxx(:,1:end-ss)), r(j));
chis2 = chi*diag(stand);
cirfi = PROXYSVARRecoverabilityCase([chis2(:,vari1) pc2(:,1:r(j)-length(vari1)) ],instr,p,H,1,cumvar2,nrepli,ffrpos,1,m);
cir(:,:,j) = squeeze(cirfi(1:7,:,:))./cirfi(1,1,1);
end
% time span
instr = xx(:,126);
instr = instr(1+t1:end - endcut);
x = xx(1+t1:end-endcut,1:end);
[pc1,R,D,chi] = principalcomponents(standardize(x(:,1:end-ss)), rhat3);
stand = std(x(:,1:end-ss));
chis1 = chi*diag(stand);
cirfu = PROXYSVARRecoverabilityCase([chis1(:,vari1) pc1(:,1:rhat3-length(vari1)) ],instr,p,H,1,cumvar2,nrepli,ffrpos,1,m);
cirfu = squeeze(cirfu)./cirfu(1,1,1);


% plotting robustness figure
figure(11)
s=n;
for i=1:n    
    imp = [bench(i,1:KK)' squeeze(prctile(benchboot(i,1:KK,:),[ 16 84 ],3))];
    subplot(s,4,4*(i-1)+1),PlotShad2(imp), hold on
    for j=1:2,plot(0:KK-1,ci(i,1:KK,j),'LineWidth', 2);end
    ylabel(nomi{i})
    if i==1, title('Changing p'),end
    axis tight
    grid 'minor'
end
for i=1:n  
    imp = [bench(i,1:KK)' squeeze(prctile(benchboot(i,1:KK,:),[ 16 84 ],3))];
    subplot(s,4,4*(i-1)+3),PlotShad2(imp), hold on
    %plot(0:KK-1,irfss4(i,1:KK),'LineWidth', 2)
    plot(0:KK-1,cirf(i,1:KK),'LineWidth', 2)
    %plot(0:KK-1,cirff(i,1:KK),'LineWidth', 2)
    if i==1, title('Changing the instrument'),end
    axis tight
    grid 'minor'
end

for i=1:n    
    imp = [bench(i,1:KK)' squeeze(prctile(benchboot(i,1:KK,:),[ 16 84 ],3))];
    subplot(s,4,4*(i-1)+2),PlotShad2(imp), hold on
    for j=1:2,plot(0:KK-1,cir(i,1:KK,j),'LineWidth', 2);end
    ylabel(nomi{i})
    if i==1, title('Changing the number of factors'),end
    axis tight
    grid 'minor'
end
for i=1:n    
    imp = [bench(i,1:KK)' squeeze(prctile(benchboot(i,1:KK,:),[ 16 84 ],3))];
    subplot(s,4,4*(i-1)+4),PlotShad2(imp), hold on
    plot(0:KK-1,cirfu(i,1:KK),'LineWidth', 2)
   
    ylabel(nomi{i})
    if i==1, title('Changing the sample span'),end
    axis tight
    grid 'minor'
end