%% The effects of technology shocks

clear
close all 
clc
FactorsQ

cut = 0;

name{223} = 'Hours';
name{123} = 'Labor Productivity';
name{212} = 'TFP';
name{57} = 'Unemployment';
name{228} = 'GDP Deflator';
name{128} = 'Federal Funds Rate';
name{227} = 'Per Capita GDP';
name{225} = 'Per Capita Consumption';
name{226} = 'Per Capita Investment';
xs = standardize(x(:,:));
[T, n] = size(xs);
V = cov(xs);

%% Estimate the number of common factor
kmax = 20;
for k = 1:50 
[rhat1(k), rhat2(k)] = ABC_crit(xs, kmax);
end
rhat1 = round(mean(rhat1));
rhat2 = round(mean(rhat2))
%r = round(mean([rhat1 rhat2]))
r=13;


%% Compute the principal components 
[pc,R,D,chi] = principalcomponents(xs , r);
varchi = diag(R*D*R')*100;

[(1:n)' varchi];
stand = std(x(:,1:end));
chis = chi*diag(stand);

%% dati con ore in livelli
FactorsQlev


xs1 = standardize(x1(:,:));
[T,n] = size(xs1);
V = cov(xs1);

%% Compute the principal components 
kmax = 20;
for k = 1:50 
[rhat1(k), rhat2(k)] = ABC_crit(xs1, kmax);
end
rhat1 = round(mean(rhat1));
rhat2 = round(mean(rhat2))
%r = round(mean([rhat1 rhat2]))    
r=13;
[pc1,R,D,chi1] = principalcomponents(xs1 , r);
varchi = diag(R*D*R')*100;


stand = std(x1(:,1:end));
chis1 = chi1*diag(stand);


%% VAR with labor productivity and hours
 nrepli = 500;
 nlags = 41;

 p = 4;%4;
 p1 = 3;

%% VAR with LP and hours
v = [123  223];
y = x(:,v);


[aic,bic,hqc(2)] = aicbic(y,8)


[cirf, irfboot,psh1] = LRVAR(y,p,nlags,[1 2],nrepli,nlags);

irfss = squeeze(cirf(:,1,:));
irfssboot = squeeze(irfboot(:,1,:,:));
nn = length(v);
KK = 41;
%vv1 = ExplainedVariances(irfboot,cirf,1);

y(:,2) = cumsum(y(:,2));
[aic,bic,hqc(2)] = aicbic(y,8);

[cirf, irfboot,  psh2] = LRVAR(y,p,nlags,[1 ],nrepli,nlags);
vv2 = ExplainedVariances(irfboot,cirf,1);


%corrcoef(psh1(:,1),psh2(:,1))

irfss2 = squeeze(cirf(:,1,:));
irfssboot2 = squeeze(irfboot(:,1,:,:));

v1 = [123 223  57 50 128];
y = x(:,v1);

[cirf, irfboot,  psh3] = LRVAR(y,p,nlags,[1  2 ],nrepli,nlags);
irfss3 = squeeze(cirf(:,1,:));
irfssboot3 = squeeze(irfboot(:,1,:,:));
%abs(roots([irfss3(1,1) diff(irfss3(1,:))]))
y(:,2) = cumsum(y(:,2));
[cirf, irfboot,  psh6] = LRVAR(y,p,nlags,[ 1  ],nrepli,nlags);
irfss6 = squeeze(cirf(:,1,:));
irfssboot6 = squeeze(irfboot(:,1,:,:));

v2 = [123 223  227 225 226];
y = x(:,v2);
y(:,[1 3 4 5 ]) = cumsum(y(:,[1 3 4 5 ]));

[cirf, irfboot,  psh32] = LRVAR(y,p,nlags,[ 2 ],nrepli,nlags);
irfss32 = squeeze(cirf(:,1,:));

y(:,2) = cumsum(y(:,2));
[cirf, irfboot,  psh62] = LRVAR(y,p,nlags,[   ],nrepli,nlags);
irfss62 = squeeze(cirf(:,1,:));

v3 = [123 224 128 132 134 ];
y = x(:,v3);
%y(:,[1  ]) = cumsum(y(:,[1   ]));

[cirf, ~,  psh33] = LRVAR(y,p,nlags,[1 2 ],nrepli,nlags);
irfss33 = squeeze(cirf(:,1,:));
%irfssboot6 = squeeze(irfboot(:,1,:,:));% 
y(:,2) = cumsum(y(:,2));
[cirf, ~,  psh63] = LRVAR(y,p,nlags,[1  ],nrepli,nlags);
irfss63 = squeeze(cirf(:,1,:));
%% factor model

[cirf, irfboot,  psh4] = LRVAR([chis(:,v) pc(:,1:end-length(v))],p1,nlags,[1 2],nrepli,nlags);
%vv4 = ExplainedVariances(irfboot,cirf,1);
irfss4 = squeeze(cirf(:,1,:));
irfssboot4 = squeeze(irfboot(:,1,:,:));
abs(roots([irfss4(1,1) diff(irfss4(1,:))]));


[cirf, irfboot,  psh5] = LRVAR([chis1(:,v) pc1(:,1:end-length(v))],p1,nlags,[1 ],nrepli,nlags);
%vv5 = ExplainedVariances(irfboot,cirf,1);
irfss5 = squeeze(cirf(:,1,:));

irfssboot5 = squeeze(irfboot(:,1,:,:));
corrcoef([psh1(:,1) psh2(:,1) psh4(p-p1+1:end,1) psh5(p-p1+1:end,1)] )

%% plot
figure(6)
name{224} = 'Hours in differences';
 for i =1:nn
    imp1 = [irfss(i,1:KK)' squeeze(prctile(irfssboot(i,1:KK,:),[ 16 84 ],3))];
     subplot(nn,2,2*(i-1)+1),PlotShad2(imp1),ylabel(name{v(i)}),if i==1, title('VAR Ia'),end
      axis tight
    grid 'minor'
 end
 name{224} = 'Hours in levels';
 for i =1:nn
    imp1 = [irfss2(i,1:KK)' squeeze(prctile(irfssboot2(i,1:KK,:),[ 16 84 ],3))];
     subplot(nn,2,2*(i-1)+2),PlotShad2(imp1),ylabel(name{v(i)}),if i==1, title('VAR Ib'),end
      axis tight
    grid 'minor'
 end

 




 figure(8)
name{224} = 'Hours in differences';
 for i =1:nn
    imp1 = [irfss4(i,1:KK)' squeeze(prctile(irfssboot4(i,1:KK,:),[ 16 84 ],3))];
     subplot(nn,2,2*(i-1)+1),PlotShad2(imp1),ylabel(name{v(i)}),if i==1, title('DFMa'),end
      axis tight
    grid 'minor'
 end
name{224} = 'Hours in levels';

 for i =1:nn
    imp1 = [irfss5(i,1:KK)' squeeze(prctile(irfssboot5(i,1:KK,:),[ 16 84 ],3))];
     subplot(nn,2,2*(i-1)+2),PlotShad2(imp1),ylabel(name{v(i)}),if i==1, title('DFMb'),end
      axis tight
    grid 'minor'
 end
 
 
%% testing for fundamentalness
 u{1} = psh1(:,1);
 u{2} = psh2(:,1);
 % u{3} = psh4(:,1);
 % u{4} = psh5(:,1);
 u{7} = psh33(:,1);
 u{4} = psh6(:,1);
 u{6} = psh62(:,1);
 u{5} = psh32(:,1);
 u{3} = psh3(:,1);
 u{8} = psh63(:,1);
v = [123  223];
ydiff = x(:,v);
ylev = ydiff;
ylev(:,1) = cumsum(ydiff(:,1));
npc=7;
for i = 1:4
  for j = 1:2 
      
 
prob2(j,i) = ortotest2(u{j}, pc1(p+1:end,1:npc), i); 
prob2(j+2,i) = ortotest2(u{j}, pc1(p+1:end,1:npc), i);
 
%prob2(j+4,i) = ortotest2(u{j+2}, ylev(p1+1:end,:), i); 
%prob2(j+6,i) = ortotest2(u{j+2}, ylev(p1+1:end,:), i);
  end  
   prob2(5,i) = ortotest2(u{3}, pc1(p+1:end,1:npc), i);  
   prob2(6,i) = ortotest2(u{4}, pc1(p+1:end,1:npc), i);  
 prob2(7,i) = ortotest2(u{5}, pc1(p+1:end,1:npc), i);  
 prob2(8,i) = ortotest2(u{6}, pc1(p+1:end,1:npc), i);  
 prob2(9,i) = ortotest2(u{7}, pc1(p+1:end,1:npc), i);  
 prob2(10,i) = ortotest2(u{8}, pc1(p+1:end,1:npc), i);  
end     


probb = prob2([1 2 5:end],:);
Table2 = MakeTable(probb,3)

%% other VAR specifications

figure(7)
name{224} = 'Hours in differences';
for i =1:nn
     imp1 = [irfss(i,1:KK)' squeeze(prctile(irfssboot(i,1:KK,:),[ 16 84 ],3))];
     subplot(nn,2,2*(i-1)+1),PlotShad2(imp1),ylabel(name{v(i)}), hold on
     plot(0:KK-1,irfss3(i,1:KK)','b','LineWidth',1.5)
     if i==1, title('VAR IIa, IIIa, IVa'),end
      plot(0:KK-1,irfss32(i,1:KK)','g','LineWidth',1.5)
      plot(0:KK-1,irfss33(i,1:KK)','r','LineWidth',1.5)
      plot(0:KK-1,zeros(KK,1),'r','LineWidth',1), axis tight
    grid 'minor'
end
name{224} = 'Hours in levels';
for i =1:nn
   imp1 = [irfss2(i,1:KK)' squeeze(prctile(irfssboot2(i,1:KK,:),[ 16 84 ],3))];
     subplot(nn,2,2*(i-1)+2),PlotShad2(imp1),ylabel(name{v(i)}),hold on
     plot(0:KK-1,irfss6(i,1:KK)','b','LineWidth',1.5)
     if i==1, title('VAR IIb, IIIb, IVb'),end
      axis tight
      plot(0:KK-1,irfss62(i,1:KK)','g','LineWidth',1.5)
      plot(0:KK-1,irfss63(i,1:KK)','r','LineWidth',1.5)
       plot(0:KK-1,zeros(KK,1),'r','LineWidth',1)
    grid 'minor'
end

