function B=Ma1(A,k)

%   B = Ma1(A,k)
%--------------------------------------------------------------------
%  
%
%  compute "truncated" MA at lag k:
%              y(t)= [ I + B(2)L + B(3)L^2 + ... +B(k)L^k]e(t)
%
%  from VAR representation:
%              y(t)= A(1)y(t-1) +...+ A(p)y(t-p) + e(t)

[N N1 p]=size(A);

B=zeros(N,N,k);

B(:,:,1)=diag(ones(N,1));

for i=2:k
   s=min(i-1,p);
   for j=1:s
       B(:,:,i)=B(:,:,i)+A(:,:,j)*B(:,:,i-j); 
    end
 end
 
      
   
   
   
   
   
   
   
   
   
   
   
   