function CGF = CovarianceGeneratingFunction(MAmatrix,Sigma)
%
% CGF is an nXnX(2p+1)  3D matrix having the k-lag covariance matrices
% k = -p,...,p in the third dimension. The varcov matrix is CGF(:,:,p+1)
%


if isvector(MAmatrix)
    z = zeros(1,1,length(MAmatrix));
    z(1,1,:) = MAmatrix;
    MAmatrix = z;
end
    
[n,m,q] = size(MAmatrix);
MAT = zeros(m,n,q);
for j=1:q
    MAT(:,:,q+1-j) = Sigma*MAmatrix(:,:,j)';
end
CGF = PolynomialMatricesProduct(MAmatrix,MAT);



if size(CGF,1) == 1
    CGF = squeeze(CGF);
end