function dK = deltaK(MAmatrix,Sigma,nlagsvar)
[n,~,~] = size(MAmatrix);
nl = nlagsvar + 1;
CGF0 = CovarianceGeneratingFunction(MAmatrix, Sigma);
maxlag = (size(CGF0,3) - 1)/2;
if maxlag >= nl
    CGF = CGF0(:,:,   maxlag + 1 - nl:  maxlag + 1 + nl);
else
CGF = zeros(n, n, 1 + 2*nl);
CGF(:,:,  nl + 1 - maxlag : nl + 1 + maxlag) = CGF0;
end
A    = yule(CGF, nlagsvar); 
C         = inv(A);
G = C(1:n,1:n);
E = MAmatrix(:,:,1);
dK = 1 - diag(E'*G*E)./diag(Sigma); 






