%
% B = DfmRawImp(X, q, r,k, h)
% 
% produce la stima come descritto in Forni Lippi Reichlin 2003 
% delle impulse (non cumulate) relative al
% panel X con rango statico r e dinamico q e h ritardi
% B e' tridimensionale con  la cross-sectional unit sulla prima, 
% il common shock sulla seconda,
% il ritardo sulla terza dimensione. Le impulse in B corrispondono ad una 
% identificazione ortonormale, quale risulta determinata 
% dalla scelta degli autovettori operata dalla routine  eigs.
%
% 


function [B, chi, G,eta,u,v]  = DfmRawImp(X, q, r, k, h)
N = size(X, 2);
T = size(X, 1);
WW = diag(std(X));
x = center(X)*(WW^-1);
Gamma0 = cov(x);
opt.disp = 0;
[W, Lambda] = eigs(Gamma0, r,'LM',opt);
F = x*W;
FF = [ones(T,1) F];
QQprime = (FF'*FF)\FF'*X;
chi = FF*QQprime;
Q = QQprime(2:r+1,:)';
[BB, epsilon] = woldimpulse(F, k, h + 1);
Sigma = cov(epsilon);
[ K, MM ] = eigs(Sigma, q, 'LM',opt);
M = diag(sqrt(diag(MM)));
for lag = 1 : h + 1
    B(:, :, lag) = Q*BB(:, :, lag)*K*M;
end
G = K*M;
eta = epsilon*K*M;
e = x - F*W';
u=principalcomponents(epsilon*W',q);
v=principalcomponents(epsilon*W'+e(k+1:end,:),q);


