  
function [qnolog qlog] = HallinLiska(panel, qmax,cmax, ngrid,Tgrid)
% 

%--------------------------------------------------------------------------
%
%
% 
[T,n] = size(panel);
%
if nargin <= 2    
    ngrid = n-30:10:n;
    Tgrid = T-30:10:T;
    cmax = 3;%2
end

for j=1:length(ngrid)
    
    
    TT = Tgrid(j);
    nn = ngrid(j);
    window = floor(sqrt(TT)*0.75);
    eigv = subr_1(panel(1:TT,1:nn), window); 
    IC1 = flipud(cumsum(flipud(eigv)));
    IC1 = IC1(1:qmax+1,:);

    p = ((window/TT)^0.5 + window^(-2) + nn^(-1))*log(min([(TT/window)^0.5;  window^2; nn]));
    
    
    for c = 1:cmax*100+1
        cc = (c-1)/100;
       IC = IC1/nn + (0:qmax)'*p*cc;
       [~,qq] = min(IC);
       q1(j,c) = qq-1;
    
       IC_log = log(IC1/nn) + (0:qmax)'*p*cc;
       [~,qq] = min(IC_log);
       q2(j,c) = qq-1;
        
       
    end %c
end %n


qstableindex = find(std(q1) == 0);
qstableindexnoqmax = find(q1(end, qstableindex) < qmax);
qnolog = q1(end, qstableindex(qstableindexnoqmax(1)) );


qstableindex = find(std(q2) == 0);
qstableindexnoqmax = find(q2(end, qstableindex) < qmax);
qlog = q2(end, qstableindex(qstableindexnoqmax(1)) );
%q = [qnolog qlog];




%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function  E = subr_1(x, M)

%x = center(x);
% define some useful quantities
[T,N] = size(x);
w = M;
W = 2*w+1;
% compute covariances 
SS = zeros(W,N*N);
for k = 1:w+1,
     Sk = center(x(k:T,:))'*center(x(1:T+1-k,:))/(T-k);
     S_k = Sk';
     % the x(:) creates a column vector from the matrix x columnwise
     SS(w-k+2,:) = S_k(:)';  
     SS(w+k,:) = Sk(:)';
end


% compute the spectral matrix in w points (S)
% [0:2*pi/W:4*pi*w/W]
%Factor = exp(-sqrt(-1)*(-w:w)'*(0:2*pi/W:4*pi*w/W));


freq = [0:2*pi/W:pi];
Factor = exp(-sqrt(-1)*(-w:w)'*freq);

ww = 1 - abs([-w:w])/(w+1);

% multiply first line of SS by ww(1)
% multiply second line of SS by ww(2)

S = diag(ww)*SS(1:W,:); 

% inverse to the (:) operation
% S = reshape(S'*Factor,N,N*W);

S = reshape(S'*Factor,N,N*(w+1));

% compute the eigenvalues 
eigenvalues = zeros(N,w+1);
D = eig(S(:,1:N));
eigenvalues(:,1) = flipud(sort(real(D)));

for j = 1:w,
   D = eig(S(:,j*N+1:(j+1)*N));
   eigenvalues(:,1+j) = flipud(sort(real(D)));
end
%eigenvalues
%[eigenvalues(:,1)  eigenvalues(:,2:jj+1)*2]
E = [eigenvalues(:,1)  eigenvalues(:,2:w+1)*2]*ones(w+1,1)/(2*w+1);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function XC = center(X)

[T n] = size(X);
XC = X - ones(T,1)*mean(X); 
XC = XC./kron(ones(T,1),std(XC));





