% ML_GenerateVAR

% Written by Matteo Luciani (matteo.luciani@ulb.ac.be)

function yhat=ML_GenerateVAR(y,AL,u,det,p,mu,b)

[T, n]=size(y);

A=ML_VAR_companion_matrix(AL);                                              % write VAR(1)
v=[zeros(n,1) u']; v=cat(1,v,zeros((p-1)*n,T-p+1));                         % ------------
y0=[]; for pp=p:-1:1; y0=cat(1,y0,y(pp,:)'); end; x(:,1)=y0;                % initial condition
if det==0; mu=zeros(p*n,1); else mu=cat(1,mu,zeros((p-1)*n,1)); end         % constant
if det<2; b=zeros(p*n,1); else b=cat(1,b,zeros((p-1)*n,1)); end             % time trend
for tt=2:T-p+1; x(:,tt)=mu+b*(tt+p-1)+A*x(:,tt-1)+v(:,tt); end              % generate data
yhat=x(1:n,2:end)';



% ML_decomposition - Given a series of shocks/residuald u construct Yhat=inv(I-A(L))*u=B(L)u
%
% yhat=ML_decomposition(y,beta,u,det,H)
%   yhd T by q by n
%   beta coefficients of the VAR, p*n+det by n
%   u = structural shocks
%   det = deterministic component in the VAR
%   H rotation matrix for structural shocks (optional)
%   v = u*H
%
