function [x_smooth_new,Sig_10_new,Sig_11,x_10,x_11] = kalman_smoother_luca_new(y_data,A,B,C,D,Konst);

% fro Wiki: modified BrysonFrazier (MBF) fixed interval smoother developed by Bierman
% model 
% x_t = Ax_t-1 + e_t            Vcov(e_t) = B
% y_t = Konst + Cx_t + v_t      Vcov(v_t) = D
%
ym = y_data;
nt=size(ym,1);
ny=size(ym,2);
nx=size(A,1);
nx2=size(B,2);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%initialise from steady state distribution of the states
x1 = zeros(nx,1);
x_10(:,1) = x1;% 1|0 
Sigma_1 = dly(A,B);
Sig_10(:,:,1) = Sigma_1;% 1|0
Sig_10_new(:,:,1) = Sigma_1;% 1|0

for it = 1:nt
    
    y0 = ym(it,:)';    
    e(:,it) = y0 - C*x1 - Konst; % states - (cond. E of states) (v_t)
    
    Omega = C*Sigma_1*transpose(C) + D;
    Omega = 0.5*(Omega + Omega');
    iOmega(:,:,it)   = inv(Omega);
    
    K = Sigma_1*C'*iOmega(:,:,it); % Kalman gain matrix
    
    % update
    x0 = x1 + K*e(:,it); % 1|1
    x_11(:,it) = x0;
    
    x1 = A*x0; % forecast of the state: 2|1;
    x_10(:,it+1) = x1;
    
    % update
    Sigma_0 = (eye(nx) - K*C)*Sigma_1; % 1|1
    Sig_11(:,:,it) = Sigma_0;

%    Sigma_1 = A*Sigma_0*A' + B; % forecast of the Vcov 2|1 (P_t)
    
%    Sig_10(:,:,it+1) = Sigma_1;    
    
    K2 = A*Sig_10_new(:,:,it)*C'*iOmega(:,:,it);
    L(:,:,it) = A - K2*C;
    Sig_10_new(:,:,it+1) = A*Sig_10_new(:,:,it)*L(:,:,it)' + B;
    Sigma_1 = Sig_10_new(:,:,it+1);
    Sig_10_new(:,:,it+1) = 0.5*(Sig_10_new(:,:,it+1) + Sig_10_new(:,:,it+1)');
    
%    Sig_10(:,:,it+1) = 0.5*(Sig_10(:,:,it+1) + Sig_10(:,:,it+1)');
%    J2(:,:,it) = Sig_11(:,:,it)*A'*pinv(Sig_10(:,:,it+1));    
    %it
end
x_10 = x_10(:,1:nt);

%J2 = J2(:,:,1:nt-1);
%x_10 = x_10(:,1:nt);
%Sig_10 = Sig_10(:,:,1:nt);
Sig_10_new = Sig_10_new(:,:,1:nt);

%x_smooth(:,nt) = x_11(:,nt);
%Sigma_smooth(:,:,nt) = Sig_11(:,:,nt);

%for it = nt-1:-1:1
%    x_smooth(:,it) = x_11(:,it) + J2(:,:,it)*(x_smooth(:,it+1) - x_10(:,it+1));
%    Sigma_smooth(:,:,it) = Sig_11(:,:,it) + J2(:,:,it)*(Sigma_smooth(:,:,it+1) - Sig_10(:,:,it+1))*J2(:,:,it)';
%end

r = zeros(nx,1);
Sigma_smooth_new(:,:,nt) = Sig_11(:,:,nt);

for it = nt-1:-1:0
    r = C'*iOmega(:,:,it+1)*e(:,it+1) + L(:,:,it+1)'*r;
    x_smooth_new(:,it+1) = x_10(:,it+1) + Sig_10_new(:,:,it+1)*r; 
    %Q = shock*shock';
    %R = b;
    %eta(:,it+1) = Q*R'*r;
end
%eta = eta';
x_smooth_new = x_smooth_new';
x_10 = x_10';
x_11 = x_11';
